Debian Bug report logs - #651964
cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags

version graph

Package: cdbs; Maintainer for cdbs is CDBS Hackers <build-common-hackers@lists.alioth.debian.org>; Source for cdbs is src:cdbs.

Reported by: Simon Ruderich <simon@ruderich.org>

Date: Tue, 13 Dec 2011 16:39:01 UTC

Severity: important

Tags: patch, wontfix

Found in version cdbs/0.4.105

Fixed in version cdbs/0.4.106

Done: Jonas Smedegaard <dr@jones.dk>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, simon@ruderich.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Tue, 13 Dec 2011 16:39:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon Ruderich <simon@ruderich.org>:
New Bug report received and forwarded. Copy sent to simon@ruderich.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Tue, 13 Dec 2011 16:39:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Simon Ruderich <simon@ruderich.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Tue, 13 Dec 2011 17:34:18 +0100
Package: cdbs
Severity: important
Tags: patch

Hello,

While trying to build poppler with hardening flags I noticed that
CPPFLAGS and LDFLAGS were not set correctly. This is an important
problem as it causes several hardening flags (fortify source,
relro) to not get included in the build.

Adding the following lines to class/langcore.mk.in in line 57
where CFLAGS and CXXFLAGS are already set fixes the problem:

    CPPFLAGS += $(deb_cppflags)
    LDFLAGS += $(deb_ldflags)

Regards,
Simon

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 3.1.0-1-amd64 (SMP w/8 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash




Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Tue, 13 Dec 2011 18:21:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to 651964@bugs.debian.org:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Tue, 13 Dec 2011 18:21:11 GMT) Full text and rfc822 format available.

Message #10 received at 651964@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: Simon Ruderich <simon@ruderich.org>, 651964@bugs.debian.org
Cc: comtrol@bugs.debian.org
Subject: Re: [Build-common-hackers] Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Wed, 14 Dec 2011 01:16:40 +0700
[Message part 1 (text/plain, inline)]
tags 651964 wontfix
thanks

On 11-12-13 at 05:34pm, Simon Ruderich wrote:
> While trying to build poppler with hardening flags I noticed that 
> CPPFLAGS and LDFLAGS were not set correctly. This is an important 
> problem as it causes several hardening flags (fortify source, relro) 
> to not get included in the build.
> 
> Adding the following lines to class/langcore.mk.in in line 57 where 
> CFLAGS and CXXFLAGS are already set fixes the problem:
> 
>     CPPFLAGS += $(deb_cppflags)
>     LDFLAGS += $(deb_ldflags)


Thanks for your bugreport.

I agree with you that some flags were set properly in the past.  
Unfortunately some packages depend on the old broken behaviour, so it 
can not be corrected now.

You can add the following at the top of your rules file to make CDBS 
handle compile flags more sensibly:

CDBS_FIX_COMPILE_FLAGS = 1



Kind regards,

 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private
[signature.asc (application/pgp-signature, inline)]

Added tag(s) wontfix. Request was from Jonas Smedegaard <dr@jones.dk> to control@bugs.debian.org. (Tue, 13 Dec 2011 18:30:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Tue, 13 Dec 2011 20:12:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon Ruderich <simon@ruderich.org>:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Tue, 13 Dec 2011 20:12:07 GMT) Full text and rfc822 format available.

Message #17 received at 651964@bugs.debian.org (full text, mbox):

From: Simon Ruderich <simon@ruderich.org>
To: 651964@bugs.debian.org
Subject: Re: [Build-common-hackers] Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Tue, 13 Dec 2011 21:05:18 +0100
[Message part 1 (text/plain, inline)]
On Wed, Dec 14, 2011 at 01:16:40AM +0700, Jonas Smedegaard wrote:
> [snip]
>
> I agree with you that some flags were set properly in the past.
> Unfortunately some packages depend on the old broken behaviour, so it
> can not be corrected now.
>
> You can add the following at the top of your rules file to make CDBS
> handle compile flags more sensibly:
>
> CDBS_FIX_COMPILE_FLAGS = 1

I see. This makes automatic enabling of hardening flags for cdbs
based packages difficult. I've updated the instructions on the
wiki to mention this issue [1].

Regards,
Simon

[1]: https://wiki.debian.org/ReleaseGoals/SecurityHardeningBuildFlags
-- 
+ privacy is necessary
+ using gnupg http://gnupg.org
+ public key id: 0x92FEFDB7E44C32F9
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Tue, 31 Jan 2012 20:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Moritz Muehlenhoff <jmm@inutil.org>:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Tue, 31 Jan 2012 20:51:03 GMT) Full text and rfc822 format available.

Message #22 received at 651964@bugs.debian.org (full text, mbox):

From: Moritz Muehlenhoff <jmm@inutil.org>
To: 651964@bugs.debian.org
Cc: Simon Ruderich <simon@ruderich.org>, jmm@debian.org
Subject: Re: [Build-common-hackers] Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Tue, 31 Jan 2012 21:48:23 +0100
On Wed, Dec 14, 2011 at 01:16:40AM +0700, Jonas Smedegaard wrote:
> tags 651964 wontfix
> thanks
> 
> On 11-12-13 at 05:34pm, Simon Ruderich wrote:
> > While trying to build poppler with hardening flags I noticed that 
> > CPPFLAGS and LDFLAGS were not set correctly. This is an important 
> > problem as it causes several hardening flags (fortify source, relro) 
> > to not get included in the build.
> > 
> > Adding the following lines to class/langcore.mk.in in line 57 where 
> > CFLAGS and CXXFLAGS are already set fixes the problem:
> > 
> >     CPPFLAGS += $(deb_cppflags)
> >     LDFLAGS += $(deb_ldflags)
> 
> 
> Thanks for your bugreport.
> 
> I agree with you that some flags were set properly in the past.  
> Unfortunately some packages depend on the old broken behaviour, so it 
> can not be corrected now.

Hi Jonas,
I'm currently working my way through all packages, which have had a DSA
in the last five years and/or which are of Priority >= important.
I've nearly finished all packages based on debhelper and I now proceed with
the packages based on cdbs.

Please reconsider the wontfix: Out of the three *FLAGS emitted by 
dpkg-buildflags, CFLAGS is the only option, which causes build
problems (almost exclusively due to missing format strings exposed
by "-Wformat -Wformat-security -Werror=format-security")

The two additional flags are harmless and won't cause any further
build failures:

CPPFLAGS=-D_FORTIFY_SOURCE=2 activates replaces insecure C library
calls at build time, see here for details:
http://wiki.debian.org/Hardening#DEB_BUILD_HARDENING_FORTIFY_.28gcc.2BAC8-g.2B-.2B-_-D_FORTIFY_SOURCE.3D2.29

LDFLAGS=-Wl,-z,relro activates a linker flag, see here for details:
http://wiki.debian.org/Hardening#DEB_BUILD_HARDENING_RELRO_.28ld_-z_relro.29

I've run test conversion for 200-250 packages and D_FORTIFY_SRC and
relro didn't cause any problems (plus most distros have patched their
toolchain, which enabes this by default).

So, please activate these flags as suggested by Simon, otherwise this
causes a lot of additional manual overhead. (Plus, your workaround doesn't
work, see below).
 
> You can add the following at the top of your rules file to make CDBS 
> handle compile flags more sensibly:
> 
> CDBS_FIX_COMPILE_FLAGS = 1

Doesn't work for me. In my tests it (e.g. with gdm3) it leads to 

/usr/share/cdbs/1/class/langcore.mk:65: *** Recursive variable `CFLAGS' references itself (eventually).  Stop.
dpkg-buildpackage: error: debian/rules build gave error exit status 2

Cheers,
        Moritz




Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Wed, 01 Feb 2012 00:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonas Smedegaard <dr@jones.dk>:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Wed, 01 Feb 2012 00:09:03 GMT) Full text and rfc822 format available.

Message #27 received at 651964@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: Moritz Muehlenhoff <jmm@inutil.org>, 651964@bugs.debian.org
Cc: Simon Ruderich <simon@ruderich.org>, jmm@debian.org
Subject: Re: [Build-common-hackers] Bug#651964: Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Wed, 1 Feb 2012 01:05:39 +0100
[Message part 1 (text/plain, inline)]
On 12-01-31 at 09:48pm, Moritz Muehlenhoff wrote:
> On Wed, Dec 14, 2011 at 01:16:40AM +0700, Jonas Smedegaard wrote:
> > tags 651964 wontfix
> > thanks
> > 
> > On 11-12-13 at 05:34pm, Simon Ruderich wrote:
> > > While trying to build poppler with hardening flags I noticed that 
> > > CPPFLAGS and LDFLAGS were not set correctly. This is an important 
> > > problem as it causes several hardening flags (fortify source, 
> > > relro) to not get included in the build.
> > > 
> > > Adding the following lines to class/langcore.mk.in in line 57 
> > > where CFLAGS and CXXFLAGS are already set fixes the problem:
> > > 
> > >     CPPFLAGS += $(deb_cppflags)
> > >     LDFLAGS += $(deb_ldflags)
> > 
> > 
> > Thanks for your bugreport.
> > 
> > I agree with you that some flags were set properly in the past.  
> > Unfortunately some packages depend on the old broken behaviour, so 
> > it can not be corrected now.
> 
> Hi Jonas,
> I'm currently working my way through all packages, which have had a 
> DSA in the last five years and/or which are of Priority >= important.
> I've nearly finished all packages based on debhelper and I now proceed 
> with the packages based on cdbs.
> 
> Please reconsider the wontfix: Out of the three *FLAGS emitted by 
> dpkg-buildflags, CFLAGS is the only option, which causes build 
> problems (almost exclusively due to missing format strings exposed by 
> "-Wformat -Wformat-security -Werror=format-security")
> 
> The two additional flags are harmless and won't cause any further 
> build failures:
> 
> CPPFLAGS=-D_FORTIFY_SOURCE=2 activates replaces insecure C library
> calls at build time, see here for details:
> http://wiki.debian.org/Hardening#DEB_BUILD_HARDENING_FORTIFY_.28gcc.2BAC8-g.2B-.2B-_-D_FORTIFY_SOURCE.3D2.29
> 
> LDFLAGS=-Wl,-z,relro activates a linker flag, see here for details:
> http://wiki.debian.org/Hardening#DEB_BUILD_HARDENING_RELRO_.28ld_-z_relro.29
> 
> I've run test conversion for 200-250 packages and D_FORTIFY_SRC and
> relro didn't cause any problems (plus most distros have patched their
> toolchain, which enabes this by default).
> 
> So, please activate these flags as suggested by Simon, otherwise this 
> causes a lot of additional manual overhead. (Plus, your workaround 
> doesn't work, see below).

[embarassing bug snipped]

Thanks for the investigations.  I am convinced!

I'll simplify CDBS to always use new behaviour, and hope it causes no 
breakage.


 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Wed, 29 Feb 2012 21:21:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to Moritz Mühlenhoff <jmm@inutil.org>:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Wed, 29 Feb 2012 21:21:44 GMT) Full text and rfc822 format available.

Message #32 received at 651964@bugs.debian.org (full text, mbox):

From: Moritz Mühlenhoff <jmm@inutil.org>
To: Jonas Smedegaard <dr@jones.dk>
Cc: jmm@debian.org, 651964@bugs.debian.org, Simon Ruderich <simon@ruderich.org>
Subject: Re: [Build-common-hackers] Bug#651964: Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Wed, 29 Feb 2012 22:09:55 +0100
On Wed, Feb 01, 2012 at 01:05:39AM +0100, Jonas Smedegaard wrote:

> > I've run test conversion for 200-250 packages and D_FORTIFY_SRC and
> > relro didn't cause any problems (plus most distros have patched their
> > toolchain, which enabes this by default).
> > 
> > So, please activate these flags as suggested by Simon, otherwise this 
> > causes a lot of additional manual overhead. (Plus, your workaround 
> > doesn't work, see below).
> 
> [embarassing bug snipped]
> 
> Thanks for the investigations.  I am convinced!
> 
> I'll simplify CDBS to always use new behaviour, and hope it causes no 
> breakage.

What's the status? It would be nice if that could be fixed soon, since
the Wheezy freeze is approaching rapidly.

Cheers,
        Moritz




Reply sent to Jonas Smedegaard <dr@jones.dk>:
You have taken responsibility. (Fri, 02 Mar 2012 07:51:17 GMT) Full text and rfc822 format available.

Notification sent to Simon Ruderich <simon@ruderich.org>:
Bug acknowledged by developer. (Fri, 02 Mar 2012 07:51:17 GMT) Full text and rfc822 format available.

Message #37 received at 651964-close@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: 651964-close@bugs.debian.org
Subject: Bug#651964: fixed in cdbs 0.4.103
Date: Fri, 02 Mar 2012 07:47:11 +0000
Source: cdbs
Source-Version: 0.4.103

We believe that the bug you reported is fixed in the latest version of
cdbs, which is due to be installed in the Debian FTP archive:

cdbs_0.4.103.dsc
  to main/c/cdbs/cdbs_0.4.103.dsc
cdbs_0.4.103.tar.gz
  to main/c/cdbs/cdbs_0.4.103.tar.gz
cdbs_0.4.103_all.deb
  to main/c/cdbs/cdbs_0.4.103_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 651964@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Jonas Smedegaard <dr@jones.dk> (supplier of updated cdbs package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Fri, 02 Mar 2012 06:51:17 +0100
Source: cdbs
Binary: cdbs
Architecture: source all
Version: 0.4.103
Distribution: unstable
Urgency: low
Maintainer: CDBS Hackers <build-common-hackers@lists.alioth.debian.org>
Changed-By: Jonas Smedegaard <dr@jones.dk>
Description: 
 cdbs       - common build system for Debian packages
Closes: 523642 624663 625448 651964 652274 658973
Changes: 
 cdbs (0.4.103) unstable; urgency=low
 .
   * Fix use "formatted text" (i.e. double-space-indent) for Copyright
     fields in copyright_hints.
   * Bump copyright file format to final version 1.0 in copyright_hints.
   * Always set (not extend) compiler flags.
     Closes: bug#523642, #651964. Thanks to Simon Ruderich and Moritz
     Muehlenhoff.
     Add NEWS entry.
   * Add Multi-Arch: foreign field to binary cdbs package.
     Closes: bug#658973. Thanks to Riku Voipio.
   * Fix export magic option to turn off auto-install of dependent Perl
     modules.
     Closes: bug#652274. Thanks to gregor herrmann.
   * Fix remove copyright_newhints in clean target (not immediately after
     copyright check).
     Closes: bug#625448. Thanks to Olivier Aubert.
   * Fix use scons --directory="$(DEB_SRCDIR)" (not DEB_BUILDDIR).
     Closes: bug#624663. Thanks to Jérémy Lal.
   * Bump standards-version to 3.9.3.
   * Bump copyright file format to 1.0.
Checksums-Sha1: 
 8b0e2ba2f00f44b2b5cdbf0944160514adcdecfb 1871 cdbs_0.4.103.dsc
 fd425d7f16171d42d6ffe66e56d03cad6fc8d33d 265280 cdbs_0.4.103.tar.gz
 7c253c602a5dc742b06e4027d0d0baa27723cb93 78500 cdbs_0.4.103_all.deb
Checksums-Sha256: 
 9ae5a05d7bf216d924912b20f893e3b09bc54e06df7ef6b69b90a0a242880987 1871 cdbs_0.4.103.dsc
 baf61fbcda5ff792cba3266b3d92c4e0217570076a15ffa37be2513493be02ee 265280 cdbs_0.4.103.tar.gz
 948f0d1d531d56d1d5bafdce7f1bddb43089290c32c82b68f78fa0563fab00aa 78500 cdbs_0.4.103_all.deb
Files: 
 ca04c051a6cc734589884e42ed838a1b 1871 devel optional cdbs_0.4.103.dsc
 316b9ebda552708950e4f1c7a92f5f82 265280 devel optional cdbs_0.4.103.tar.gz
 ee40e88dd475944de9e0af46f8b6ae4f 78500 devel optional cdbs_0.4.103_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCgAGBQJPUHhsAAoJECx8MUbBoAEhhHwP/1l5SI/wUX+WhZv8LFaj0fXM
ecGKgj0wtU5zDLPqlqievwfS+HgV251QeziehpmpD8Cw2ksDTi53g1UFVg04P0GY
HMP0GHkeCIq3KvQsZ78CcIfYJ/PqcnSc1FalDrr6G7ZN8lDPKs3O3w2OUHPWFyok
Qoz2NZDORo49Q4009dXBNMeF+/zt67AkdNNXnCJ7kJ7V9/g718rOcCoBtD1NxAo3
0kW6SWhnSkNhuq2OBKvOdtL2VthSYDVfquQXLfde/Q0SuNQzQ8ii21dYwj59l6Oe
vwhjmMw6Hwhfth3CFWXEqSTmexLXYhlRVV9NWaIOtIzZc8TqPxKQ9/OVwuTzSooH
wrdlGzgEG+/cJDrUriLC77QlyH60kWRyCXKWOvd2NMT6im1DT368Nd732DFD4dT4
/nktVIr5dDDUw6xEFsmdoHXYsq8UEbN2swD7QOIFwv8ymyUzCqs7a7rMEPwQO4lF
Lj62yvmmiILBP59vPxbDbC40z/BynF98KxEJynphs1SpE7Vj0jEYYGw+CsHAQy/5
uiRLg8Y8Hb/m+iYfk+toEIkzvuuDieSeUd4dgY3LfcMRa0MIt2AP4+NVHVWJk3wA
Ki5AUggFFAd0EreDLO1C85R5B1agm1wHoydqQoy9ywBSEvD6DUlMFGtSyPOhvSWF
dX5soClCXX8oHWf+Wvo9
=1cuw
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Sun, 04 Mar 2012 16:57:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Moritz Mühlenhoff <jmm@inutil.org>:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Sun, 04 Mar 2012 16:57:05 GMT) Full text and rfc822 format available.

Message #42 received at 651964@bugs.debian.org (full text, mbox):

From: Moritz Mühlenhoff <jmm@inutil.org>
To: Jonas Smedegaard <dr@jones.dk>
Cc: Moritz Muehlenhoff <jmm@inutil.org>, 651964@bugs.debian.org, Simon Ruderich <simon@ruderich.org>, control@bugs.debian.org
Subject: Re: [Build-common-hackers] Bug#651964: Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Sun, 4 Mar 2012 17:53:55 +0100
reopen 651964
thanks

On Wed, Feb 01, 2012 at 01:05:39AM +0100, Jonas Smedegaard wrote:

> > So, please activate these flags as suggested by Simon, otherwise this 
> > causes a lot of additional manual overhead. (Plus, your workaround 
> > doesn't work, see below).

[..]

> I'll simplify CDBS to always use new behaviour, and hope it causes no 
> breakage.

This doesn't work with cdbs/0.4.105:

As an example I've rebuild afuse with current cdbs. CPPFLAGS is not set
through dpkg-buildflags. "-D_FORTIFY_SOURCE=2" should be set instead of
an empty value.

make[1]: Entering directory `/home/jmm/scratch/afuse-0.2'
make[1]: F�r das Ziel �update-config� ist nichts zu tun.
make[1]: Leaving directory `/home/jmm/scratch/afuse-0.2'
touch debian/stamp-autotools-files
chmod a+x /home/jmm/scratch/afuse-0.2/./configure
mkdir -p .
cd . &&   CFLAGS="-g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -Wall" CXXFLAGS="-g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -Wall" CPPFLAGS="" LDFLAGS="-Wl,-z,relro" /home/jmm/scratch/afuse-0.2/./configure --build=x86_64-linux-gnu  --prefix=/usr --includedir="\${prefix}/include" --mandir="\${prefix}/share/man" --infodir="\${prefix}/share/info" --sysconfdir=/etc --localstatedir=/var --libexecdir="\${prefix}/lib/afuse" --srcdir=. --disable-maintainer-mode --disable-dependency-tracking --disable-silent-rules

Cheers,
        Moritz









Bug No longer marked as fixed in versions cdbs/0.4.103 and reopened. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 04 Mar 2012 16:57:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Sun, 04 Mar 2012 17:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonas Smedegaard <dr@jones.dk>:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Sun, 04 Mar 2012 17:51:03 GMT) Full text and rfc822 format available.

Message #49 received at 651964@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: Moritz Mühlenhoff <jmm@inutil.org>
Cc: 651964@bugs.debian.org, Simon Ruderich <simon@ruderich.org>
Subject: Re: [Build-common-hackers] Bug#651964: Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Sun, 4 Mar 2012 18:48:25 +0100
[Message part 1 (text/plain, inline)]
On 12-03-04 at 05:53pm, Moritz Mühlenhoff wrote:
> On Wed, Feb 01, 2012 at 01:05:39AM +0100, Jonas Smedegaard wrote:
> 
> > > So, please activate these flags as suggested by Simon, otherwise 
> > > this causes a lot of additional manual overhead. (Plus, your 
> > > workaround doesn't work, see below).
> 
> [..]
> 
> > I'll simplify CDBS to always use new behaviour, and hope it causes 
> > no breakage.
> 
> This doesn't work with cdbs/0.4.105:
> 
> As an example I've rebuild afuse with current cdbs. CPPFLAGS is not 
> set through dpkg-buildflags. "-D_FORTIFY_SOURCE=2" should be set 
> instead of an empty value.

That's odd.

Thanks!

I'll investigate closer...


 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, simon@ruderich.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Wed, 07 Mar 2012 15:48:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon Ruderich <simon@ruderich.org>:
Extra info received and forwarded to list. Copy sent to simon@ruderich.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Wed, 07 Mar 2012 15:48:11 GMT) Full text and rfc822 format available.

Message #54 received at 651964@bugs.debian.org (full text, mbox):

From: Simon Ruderich <simon@ruderich.org>
To: Debian Bug Tracking System <651964@bugs.debian.org>
Subject: Re: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Wed, 07 Mar 2012 16:44:07 +0100
Package: cdbs
Version: 0.4.105
Followup-For: Bug #651964

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Hello,

The problem is a typo in 1/class/langcore.mk.in. The following
patch fixes it:

    --- cdbs-0.4.105/1/class/langcore.mk.in 2012-03-01 23:06:31.000000000 +0100
    +++ cdbs-0.4.105/1/class/langcore.mk.in 2012-03-07 16:37:32.000000000 +0100
    @@ -56,7 +56,7 @@
     deb_cxxflag := $(call cdbs_expand_nondefaultvar,CXXFLAGS,$(deb_cxxflags))
     deb_ldflags := $(call cdbs_expand_nondefaultvar,LDFLAGS,$(deb_ldflags))
     CFLAGS ?= $(deb_cflags)
    -CPPLAGS ?= $(deb_cppflags)
    +CPPFLAGS ?= $(deb_cppflags)
     CXXFLAGS ?= $(deb_cxxflags)
     LDFLAGS ?= $(deb_ldflags)

With that change the CPPFLAGS are applied correctly.

However DEB_BUILD_MAINT_OPTIONS is still not supported (#651966),
please fix that too.

Regards,
Simon

- -- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 3.2.0-1-amd64 (SMP w/8 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJPV4JCAAoJEJL+/bfkTDL5fEsQAIx1NvP4V+VOrOqmN/rishcG
YLyifdVyPtAcLUkfW5c+C5z5T/KP608Og14QQiaJ9U4VrFt+wYfcdJBgxjjWcytQ
NO/NgYksgp7TEyeGpdZQslV7yG1BHLp5FrQCQ9WxIqmSwCiFy2RDkvH52P/Mizd4
Tp51OubAarGBuERXlV0f1LD64eLU5bo38FKaoxg8BSaksTMTgSeIh/MADEDW/oAz
dLjs3sAtBF5lk7WD5xzOwbPLPUbDB8aKioCu0rsy1CoNWNJsyeznhkuGIg69rES4
y+qT+gsNHQEgHmeNFgRm4uOmlJD18kuEn4rMGt94R4AGPD4LSS5qyp4OZTVuzbPb
7NqlN4MyGcDYNgxmW+0LqY4JowC4vmJXxQl87KWJlQIElLaDH3J40UF6sFYd6Gzr
GpIhizg89HHKg0/m0jyCkqehMkkqovadYp7nyKLVwQnw/jFrhg7w28grqjfpaqv3
MJb5M2o4ZEzpcEFIP5V6/1kRn/rJVrA2VRChMFuE5mJVIYU2+75KON+iyoeRPoDL
zvqRfHugpq7FCe6BMcngavYs8rhu8h/hXYwFKXi75lHxV/wEX8K6DqxvAK5EJQNn
juLrTzd1eWCRg3Fpk4w3Mh/zRgUNDUv+i1otaGLKBftIYoIon0gNIpBlahGM3WBN
lVIM96Y0jWOe0eNzUvg5
=TcUO
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Wed, 07 Mar 2012 18:57:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to 651964@bugs.debian.org:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Wed, 07 Mar 2012 18:57:06 GMT) Full text and rfc822 format available.

Message #59 received at 651964@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: Simon Ruderich <simon@ruderich.org>, 651964@bugs.debian.org
Subject: Re: [Build-common-hackers] Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Wed, 7 Mar 2012 19:53:24 +0100
[Message part 1 (text/plain, inline)]
Hi Simon,

On 12-03-07 at 04:44pm, Simon Ruderich wrote:
> The problem is a typo in 1/class/langcore.mk.in. The following
> patch fixes it:
> 
>     --- cdbs-0.4.105/1/class/langcore.mk.in 2012-03-01 23:06:31.000000000 +0100
>     +++ cdbs-0.4.105/1/class/langcore.mk.in 2012-03-07 16:37:32.000000000 +0100
>     @@ -56,7 +56,7 @@
>      deb_cxxflag := $(call cdbs_expand_nondefaultvar,CXXFLAGS,$(deb_cxxflags))
>      deb_ldflags := $(call cdbs_expand_nondefaultvar,LDFLAGS,$(deb_ldflags))
>      CFLAGS ?= $(deb_cflags)
>     -CPPLAGS ?= $(deb_cppflags)
>     +CPPFLAGS ?= $(deb_cppflags)
>      CXXFLAGS ?= $(deb_cxxflags)
>      LDFLAGS ?= $(deb_ldflags)
> 
> With that change the CPPFLAGS are applied correctly.

YES!!!!

If only you knew how many hours I've stared at that code, convinced that 
it had to be a simple typo because the logic was perfectly in order for 
the other ones.

Thank you, thank you, thank you!  Please remind me that I owe you a 
bewerage of choice and a cookie, when/if we meet IRL. :-D


> However DEB_BUILD_MAINT_OPTIONS is still not supported (#651966),
> please fix that too.

Yes, I intend to do that.  I looked at Raphaels comment but those other 
variables seem more like a _different_ way to extend make variables that 
I fear clash with CDBS and is not necessary.  But let's discuss that at 
that bug, not here...


 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, CDBS Hackers <build-common-hackers@lists.alioth.debian.org>:
Bug#651964; Package cdbs. (Wed, 07 Mar 2012 23:03:14 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon Ruderich <simon@ruderich.org>:
Extra info received and forwarded to list. Copy sent to CDBS Hackers <build-common-hackers@lists.alioth.debian.org>. (Wed, 07 Mar 2012 23:03:14 GMT) Full text and rfc822 format available.

Message #64 received at 651964@bugs.debian.org (full text, mbox):

From: Simon Ruderich <simon@ruderich.org>
To: 651964@bugs.debian.org
Subject: Re: [Build-common-hackers] Bug#651964: cdbs: class/langcore.mk doesn't set CPPFLAGS and LDFLAGS from dpkg-buildflags
Date: Wed, 7 Mar 2012 23:54:23 +0100
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

On Wed, Mar 07, 2012 at 07:53:24PM +0100, Jonas Smedegaard wrote:
> Hi Simon,
>
> YES!!!!
>
> If only you knew how many hours I've stared at that code, convinced that
> it had to be a simple typo because the logic was perfectly in order for
> the other ones.
>
> Thank you, thank you, thank you!  Please remind me that I owe you a
> bewerage of choice and a cookie, when/if we meet IRL. :-D

Hi Jonas,

You're welcome, glad I could help ;-)

Took me a while to find it too, those typos are hard to spot.

> Yes, I intend to do that.  I looked at Raphaels comment but those other
> variables seem more like a _different_ way to extend make variables that
> I fear clash with CDBS and is not necessary.  But let's discuss that at
> that bug, not here...

Great, thank you.

Regards,
Simon
- -- 
+ privacy is necessary
+ using gnupg http://gnupg.org
+ public key id: 0x92FEFDB7E44C32F9
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iQIcBAEBCAAGBQJPV+cfAAoJEJL+/bfkTDL58Q0P/2S/kzbrebRCF2bPntBdaqTn
jAkmzriNI8q+4/nHoJZ4t/d8yA+kGX9PJuzaTDqsxhLkzPlcci/soB8rmZZjDc0R
z7cm/g17MOwWG9V98bv1dsatVGNHA0MyHtoX457i32Hb4OY4dR8iZPVnVJr9iThW
SIXgHceRH6UCEF1EQhaPGSLJEIot78W6bN48tBnPPKm4cZLJpvGSI7rccx5TvRdD
W91fM5ZTESebtYfOGNWjUTmV9jhso6PCGvz3/ZaQGtxN0NL2b55s06hyKETF3TNA
0p9YHiUPaynKs9IICIDx1sFMsNBeeQtHsODkso8FFWbk2ZUk1St+1+QoBe+N5pdT
/8hY78S4U3STQgGKl/j2p9WqyMEBjABAy/DRLbh8I++dTIj4ksxkY0BOzkeCwYQW
XLAT1Z8dNwBnfploehi/Zqk0p3zLuOFszdqopClgT29uGj7kxaUCw5WCTiFnMRoV
GClp89rWuIia5UgiNUhAtGu37mKL6XrPeGmDpHEmncpPnorVwXGs0WkVoOpayV6i
pT0yroCJLBxEGa8Jf4mMTryqZHfKL9Qfep/POp8STheTfV3eqmv4qZTrYD02Us6E
PHqLKdBESC0IHjxerisGYBc/tdu6I8+Hn4TjBPw7ADoNxN9ntb1iqGoMqJKWcvBt
/H0avOF/4jxi48xQxtsZ
=H+t7
-----END PGP SIGNATURE-----




Reply sent to Jonas Smedegaard <dr@jones.dk>:
You have taken responsibility. (Thu, 08 Mar 2012 04:06:09 GMT) Full text and rfc822 format available.

Notification sent to Simon Ruderich <simon@ruderich.org>:
Bug acknowledged by developer. (Thu, 08 Mar 2012 04:06:10 GMT) Full text and rfc822 format available.

Message #69 received at 651964-close@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: 651964-close@bugs.debian.org
Subject: Bug#651964: fixed in cdbs 0.4.106
Date: Thu, 08 Mar 2012 04:02:54 +0000
Source: cdbs
Source-Version: 0.4.106

We believe that the bug you reported is fixed in the latest version of
cdbs, which is due to be installed in the Debian FTP archive:

cdbs_0.4.106.dsc
  to main/c/cdbs/cdbs_0.4.106.dsc
cdbs_0.4.106.tar.gz
  to main/c/cdbs/cdbs_0.4.106.tar.gz
cdbs_0.4.106_all.deb
  to main/c/cdbs/cdbs_0.4.106_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 651964@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Jonas Smedegaard <dr@jones.dk> (supplier of updated cdbs package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Thu, 08 Mar 2012 04:06:35 +0100
Source: cdbs
Binary: cdbs
Architecture: source all
Version: 0.4.106
Distribution: unstable
Urgency: low
Maintainer: CDBS Hackers <build-common-hackers@lists.alioth.debian.org>
Changed-By: Jonas Smedegaard <dr@jones.dk>
Description: 
 cdbs       - common build system for Debian packages
Closes: 642950 651964 651966 661983
Changes: 
 cdbs (0.4.106) unstable; urgency=low
 .
   * Fix set libexecdir to /usr/lib (not /usr/lib/$pkg) in
     autotools-vars.mk.
     Closes: bug#661983. Thanks to Rémi Denis-Courmont.
   * Fix strip PD libraries below per-package install dirs (only for
     single-binary-package below debian/tmp).
     Closes: Bug#661983. Thanks to Felipe Sateler.
   * Fix set CPPFLAGS (not bogus CPPLAGS) in langcore.mk.
     Closes: bug#651964. Thanks (again) to Simon Ruderich and Moritz
     Muehlenhoff.
   * Fix create cruft subdirs before using them in utils.mk. Bump
     resolved build-dependency on cdbs as cruft handling was completely
     broken previously.
   * Handle FFLAGS in langcore.mk.
   * Re-issue news about changes to compiler flags:
     + LDFLAGS was broken when previously announced (in 0.4.103).
     + FFLAGS in also handled now.
     + Advertise use of /usr/share/dpkg/buildflags.mk, now supported
       but explicitly required as it clashes with flags explicitly set or
       unset locally in rules files.
       Closes: bug#651966, #642950. Thanks to Simon Ruderich and Raphael
       Hertzog.
   * Fix Makefile.am to use pkglibexec_SCRIPTS and avoid libexecdir.
   * Update autotools (with autoreconf -f -i).
   * Update copyright file:
     + Fix double-indent copyright lines.
     + Extend copyright years for automade files.
     + Add copyright holders for Makefile.in files.
Checksums-Sha1: 
 4a0b61f771136a7e675f1206e5476be133c02c9d 1833 cdbs_0.4.106.dsc
 6b6cb266bec1de6082ad09a45312caa47e892cee 266417 cdbs_0.4.106.tar.gz
 6be6bd33e42b7bdf7b9d9af14b731d7d2a35cbe9 79404 cdbs_0.4.106_all.deb
Checksums-Sha256: 
 28752f2d1a117d9c4e98d25e925bac0fd5d6bcc7cc76b06fa6249fd7f6d0d49a 1833 cdbs_0.4.106.dsc
 10e3d8959be7161913abe8b8124884f0eada4c801e2d0bb20509b052d2915718 266417 cdbs_0.4.106.tar.gz
 1e2562c4cfd6739ff426377397df5e4a91b4d6941c5b32e47f83359926d3fbdd 79404 cdbs_0.4.106_all.deb
Files: 
 950c76889b71245e0e81d3f8ddde1c3c 1833 devel optional cdbs_0.4.106.dsc
 f820afeafd518e95ad3d5c8864e36274 266417 devel optional cdbs_0.4.106.tar.gz
 ea24c71a7612aadac793faa30b412c99 79404 devel optional cdbs_0.4.106_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCgAGBQJPWC4ZAAoJECx8MUbBoAEhFd0P/2mH6clEqU5CcDNGAm4oKh9D
Y7Fd2vEEyvW0PZEJoj6p5RSEGBVrBfP2INpB45voDRrR4t9AljaZTkVvwPz4B3Hu
XqJfRgstiEY7PGfZgeW6W3vHnnqnl+4MVldtzFjSns3SA1Ckl7cU4BvO4a8cVb4s
21/z9tXeMrzKQdwqFQyJe4K70ZiyvEBDAtg5Rzev0Er/saM8jKvEEt0Msc+9/qht
BNdZ0040BlrFXBSO2K+ZAcdChXh5zz1vbdfBqGRleqZCiQ5jjEFBiKjUyP5db1aU
TTFx6bV1YVneqiE9iLFVdKZq132TgeulhUtSpoMUrAdrv8eeADQ/2Wfu68FXX1B7
dSoP5FM9KKbNvDGEK5SgRLzqg9oSQIw2pum8jyQ8amIUk2SJ95D4flkErlcYsglo
YYNz4zgzIBG34rNukOWnWlW3Qk79ExPs5VmO1k7Nf7bq0myBzB+N8n2YVzFStEyt
RuqpZSgpeheTfKf90Rk3oqqw6oQchDpQW2MazVQfYhv2xcwdEYGqbvW3NyuWER8c
KROcc6vSnwp8qzfyI7ge9HTYF5mIJETuIquhUWIltpYCLit7dE6HZQnquV9w1sPz
fHQkH9eekZkO5ARwXAXJ7chjclzXWXsHXCOWlx7EKi10tK14kWXAZZmWD5A+ibqC
94L80VGl2ocGpwZwnIOf
=6knZ
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 06 Apr 2012 07:35:49 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 22:35:14 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.